<template lang="pug">
.q-pa-sm
  .row.justify-center.q-col-gutter-sm.q-pt-lg(v-if="config")
    .col-sm-9.col-md-8.col-12
      q-form.q-gutter-md(@submit="onSubmit")
        .text-h3.text-center.q-pb-sm.q-mt-xl {{ $t('phase.phase_' + phase) }}

        .text-center.text-body1.text-weight-light.info.q-my-lg {{ $t('phasedescriptions.phase_' + phase) }}
        .text-center.text-body1.text-weight-light.info.q-my-lg {{ $t('prioritise_health') }}

        .text-center
          q-btn.q-pa-none.q-ma-none(
            type="a",
            outline,
            rounded,
            color="primary",
            :icon-right="fabYouTube",
            :label="$t('innovation_stories')",
            href="https://www.youtube.com/playlist?list=PLRcfk-I9AA9m85ltSwWrv3gVCz8RfG0-B",
            target="_blank"
          )

        q-banner.col.bg-orange-5.text-white(dense, rounded) {{ $t('upload_again') }}
          template(v-slot:avatar)
            q-icon(:name="matInfo", color="white")

        Phase1(
          ref="formInput",
          v-if="phase == '1'",
          :files="files",
          :submission="submission",
          :countryList="regions",
          :commsLanguages="commsLangs",
          :languageList="languages",
          :tagOptions="tagOptions",
          :selectedTags="selectedTags",
          v-on:rejected="onRejected"
        )

        Phase2(
          ref="formInput",
          v-if="phase == '2'",
          :files="files",
          :submission="submission",
          :countryList="regions",
          :commsLanguages="commsLangs",
          :languageList="languages",
          :tagOptions="tagOptions",
          :selectedTags="selectedTags",
          v-on:rejected="onRejected"
        )

        PhaseSubmission(
          ref="formInput",
          v-if="phase == 'submit'",
          :files="files",
          :submission="submission",
          :countryList="regions",
          :commsLanguages="commsLangs",
          :languageList="languages",
          :tagOptions="tagOptions",
          :selectedTags="selectedTags",
          v-on:rejected="onRejected"
        )

        div
          //- metadata
          .text-center.q-my-lg
            q-icon(:name="matInfo", size="lg")
            .text-h6 {{ $t('information') }}

          q-select.full-width(
            outlined,
            v-model="submission.language",
            :label="$t('language_recorded_in')",
            emit-value,
            map-options,
            :options="commsLangs",
            :rules="[(val) => !!val || $t('language_required')]"
          )
            template(v-slot:before)
              q-icon(:name="matTranslate", size="lg")

          q-field.full-width(
            outlined,
            ref="tags",
            :error="!hasTags",
            :error-message="$t('tag_required')"
          )
            .q-py-md
              q-chip.q-pl-md.q-pr-sm(
                :key="tag.value",
                size="lg",
                v-for="tag of tagOptions",
                :selected.sync="selectedTags[tag.value]",
                :outline="!selectedTags[tag.value]",
                :dark="selectedTags[tag.value]",
                color="primary",
                text-color="white",
                :icon="tag.icon",
                :icon-selected="tag.icon"
              )
                q-tooltip {{ tag.label }}
            template(v-slot:before)
              q-icon(:name="matStyle", size="lg", color="grey-8")

          q-select.q-pt-md.full-width(
            outlined,
            v-model="submission.region",
            emit-value,
            map-options,
            :label="$t('country_im_in')",
            :options="regions",
            :rules="[(val) => !!val || $t('country_required')]"
          )
            template(v-slot:before)
              q-icon(:name="matPublic", size="lg")
            template(v-slot:selected-item="scope")
              q-item(v-bind="scope.itemProps", v-on="scope.itemEvents")
                q-item-section.flag(avatar) {{ scope.opt.flag }}
                q-item-section
                  q-item-label {{ scope.opt.label }}

            template(v-slot:option="scope")
              q-item(v-bind="scope.itemProps", v-on="scope.itemEvents")
                q-item-section.flag(avatar) {{ scope.opt.flag }}
                q-item-section
                  q-item-label {{ scope.opt.label }}
            </q-item-section>
          </q-item>

          q-select.full-width(
            outlined,
            v-model="submission.commslanguage",
            :label="$t('language_we_will_use_when_messaging_you')",
            emit-value,
            map-options,
            :options="commsLangs",
            :rules="[(val) => !!val || $t('communication_language_required')]"
          )
            template(v-slot:before)
              q-icon(:name="matEmail", size="lg")

        div
          q-field(
            outlined,
            color="black",
            bg-color="green-2",
            :error-message="$t('accept_terms_error')",
            :error="!hasAccepted"
          )
            .full-width.q-py-sm
              .text-body1 {{ $t('media_release_title') }}
              div <a href="/policy" target="_blank">{{ $t('terms_privacy_policy') }}</a>
              .text-body1
                ul
                  li(v-for="msg of messages.media_release") {{ msg }}
              .text-right
                q-toggle(
                  v-model="accept",
                  left-label,
                  :label="$t('accept_agreement')",
                  dark,
                  size="lg"
                )
            template(v-slot:before) 
              q-icon(:name="matPolicy", size="lg")
        .row.q-mt-lg.justify-between
          .col-auto
            q-btn(
              to="/submission",
              :icon="matWest",
              size="lg",
              flat,
              rounded,
              color="black"
            ) {{ $t('back') }}
          .col-auto
            q-btn(
              color="black",
              rounded,
              :icon-right="matSend",
              unelevated,
              size="lg",
              :label="$t('submit')",
              type="Submit"
            )
    .fixed-full.dimmed(v-if="uploading")
      .dimmed
        .dimmed
          .z-top.absolute-center.text-white.text-center
            .text-h3(style="max-width: 700px; width: 80vw") {{ $t('uploading') }}
            .text-body1.q-mt-md {{ $t('dont_close') }}
            q-linear-progress.q-my-lg(size="15px", :value="progress", rounded)
</template>

<script>
/* eslint-disable no-undef */
import { mapActions, mapState, mapGetters } from "vuex";
import Phase1 from "@/components/forms/Phase1";
import Phase2 from "@/components/forms/Phase2";
import PhaseSubmission from "@/components/forms/PhaseSubmission";
const regions = require("@/ifrclist.json");
const langmap = require("@/language-mapping-list");
import each from "lodash/each";
import map from "lodash/map";
import zipObject from "lodash/zipObject";
import fill from "lodash/fill";
import size from "lodash/size";
import Language from "@/mixins/Language";
import { EventBus } from "@/event-bus";
import { fabYoutube } from "@quasar/extras/fontawesome-v5";
import langs from "../langs";

export default {
  name: "SubmissionForm",
  mixins: [Language],
  components: {
    Phase1,
    Phase2,
    PhaseSubmission,
  },
  watch: {
    selectedTags: {
      deep: true,

      handler() {
        let arr = [];
        for (const [k, v] of Object.entries(this.selectedTags)) {
          if (v) arr.push(k);
        }

        this.submission.tags = arr;
      },
    },
    loading: {
      immediate: true,
      handler(val) {
        if (val) {
          this.$q.loading.show({
            delay: 400, // ms
          });
        } else {
          this.$q.loading.hide();
        }
      },
    },
  },
  async created() {
    this.loading = true;
    this.fabYouTube = fabYoutube;
    try {
      await Promise.all([
        await this.initConfig(),
        await this.getSubmissions(true),
      ]);
    } catch (e) {
      this.$router.replace("/submission");
    }

    //check if they already have a submission
    // console.log(this.canSubmit());
    if (!this.canSubmit()) {
      this.$router.replace("/submission");
    }

    EventBus.$on("upload_progress", this.updateProgress);

    this.selectedTags = zipObject(
      Object.keys(this.config.tag_options),
      fill(Array(size(this.config.tag_options)), false)
    );

    // console.log(this.selectedTags);
    this.loading = false;
  },
  computed: {
    messages() {
      return this.$i18n.messages[this.$i18n.locale];
    },
    hasTags() {
      return this.submission.tags.length;
    },
    hasAccepted() {
      return this.accept;
    },
    phase() {
      // return "submit";
      return this.config.current_phase;
    },
    commsLangs() {
      let lngs = [];
      for (let l of langs)
        lngs.push({
          label: this.codeToLang(l),
          value: l,
        });
      return lngs;
    },
    languages() {
      let tmp = [];
      each(langmap, (a, k) => {
        if (k.length == 2)
          tmp.push({
            value: k,
            label: a.nativeName,
          });
      });
      return tmp;
    },
    regions() {
      // let tmp = [];
      // console.log(regions);
      return map(regions, (r) => {
        return {
          value: r.code,
          flag: r.flag,
          label: r.name,
        };
      });
    },
    tagOptions() {
      return map(this.config.tag_options, (k, v) => {
        return {
          label: this.$t("tags." + v),
          value: v,
          icon: this.getTagIcon(v),
        };
      });
    },
    ...mapState(["config"]),
    ...mapGetters(["getTagIcon"]),
  },
  methods: {
    updateProgress(progress) {
      // console.log("progress", progress);
      this.progress = progress;
    },
    async onSubmit() {
      try {
        if (!(await this.$refs.formInput).validateMe()) {
          this.uploading = false;
          return;
        }

        if (this.accept !== true) {
          this.uploading = false;
          return;
        }

        if (this.$refs.tags.error) {
          this.uploading = false;
          return;
        }

        this.uploading = true;

        await this.submitAction({
          submission: this.submission,
          files: this.files,
          phase: this.phase,
        });

        //artificial delay to wait for the firebase function to set new state:
        setTimeout(async () => {
          await this.getSubmissions(true);
          this.$router.replace("/submission");
        }, 3000);
      } catch (e) {
        console.log(e);
        //report failure
        this.showError(this.$t("submission_failed"));
        this.uploading = false;
      }
    },
    onRejected() {
      this.$q.notify({
        color: "secondary",
        textColor: "white",
        icon: this.matWarning,
        message: this.$t("video_size_warning"),
      });
    },
    ...mapActions(["submitAction", "initConfig", "getSubmissions"]),
    ...mapGetters(["canSubmit"]),
  },
  data() {
    return {
      selectedTags: {},
      submission: { tags: [], formdata: {} },
      files: [null, null, null, null, null],
      accept: false,
      uploading: false,
      progress: 0,
      loading: true,
    };
  },
};
</script>

<style src="@platyplus/humanitarian-icons/dist/icons.css">
/* global styles */
</style>

<style lang="scss" scoped>
.info {
  font-size: 1.5em;
}

.flag {
  font-size: 2.5em;
}
</style>
